package org.tupeloproject.pchal2;

import org.tupeloproject.rdf.Resource;
import static org.tupeloproject.rdf.UriRefFactory.t2;

/**
 * Ontology
 */
public class Ontology {
    public static Resource pc2(String s) {
        return t2("/pc2/"+s);
    }

    // generic terms

    // types
    public static final Resource STEP_TYPE = pc2("Step");
    public static final Resource DATASET_TYPE = pc2("Dataset");
    public static final Resource ANNOTATION_TYPE = pc2("Annotation");

    // step properties
    public static final Resource STEP_EXECUTED_AT = pc2("stepExecutedAt");
    public static final Resource STEP_HAS_INPUT = pc2("stepHasInput");
    public static final Resource STEP_HAS_OUTPUT = pc2("stepHasOutput");

    // annotations
    public static final Resource HAS_ANNOTATION = pc2("hasAnnotation");
    public static final Resource ANNOTATION_HAS_NAME = pc2("annotationHasName");
    public static final Resource ANNOTATION_HAS_VALUE = pc2("annotationHasValue");

    // dependency
    public static final Resource DEPENDS_ON = pc2("dependsOn");
    
    // workflow-specific terms

    // steps

    // this predicate represents the "official" name of the step in the workflow description
    // e.g., "3. align_warp"
    public static final Resource STEP_NAME = pc2("wf/stepName");

    public static final Resource ALIGN_WARP_1 = pc2("wf/alignWarp1");
    public static final Resource ALIGN_WARP_2 = pc2("wf/alignWarp2");
    public static final Resource ALIGN_WARP_3 = pc2("wf/alignWarp3");
    public static final Resource ALIGN_WARP_4 = pc2("wf/alignWarp4");

    public static final Resource RESLICE_1 = pc2("wf/reslice1");
    public static final Resource RESLICE_2 = pc2("wf/reslice2");
    public static final Resource RESLICE_3 = pc2("wf/reslice3");
    public static final Resource RESLICE_4 = pc2("wf/reslice4");

    public static final Resource SOFTMEAN = pc2("wf/softmean");

    public static final Resource SLICER_X = pc2("wf/slicerX");
    public static final Resource SLICER_Y = pc2("wf/slicerY");
    public static final Resource SLICER_Z = pc2("wf/slicerZ");

    public static final Resource CONVERT_X = pc2("wf/convertX");
    public static final Resource CONVERT_Y = pc2("wf/convertY");
    public static final Resource CONVERT_Z = pc2("wf/convertZ");

    // datasets
    public static final Resource REFERENCE_IMAGE = pc2("wf/referenceImage");
    public static final Resource REFERENCE_HEADER = pc2("wf/referenceHeader");
    
    public static final Resource ANATOMY_IMAGE_1 = pc2("wf/anatomyImage1");
    public static final Resource ANATOMY_IMAGE_2 = pc2("wf/anatomyImage2");
    public static final Resource ANATOMY_IMAGE_3 = pc2("wf/anatomyImage3");
    public static final Resource ANATOMY_IMAGE_4 = pc2("wf/anatomyImage4");

    public static final Resource ANATOMY_HEADER_1 = pc2("wf/anatomyHeader1");
    public static final Resource ANATOMY_HEADER_2 = pc2("wf/anatomyHeader2");
    public static final Resource ANATOMY_HEADER_3 = pc2("wf/anatomyHeader3");
    public static final Resource ANATOMY_HEADER_4 = pc2("wf/anatomyHeader4");

    public static final Resource WARP_PARAMETERS_1 = pc2("wf/warpParameters1");
    public static final Resource WARP_PARAMETERS_2 = pc2("wf/warpParameters2");
    public static final Resource WARP_PARAMETERS_3 = pc2("wf/warpParameters3");
    public static final Resource WARP_PARAMETERS_4 = pc2("wf/warpParameters4");

    public static final Resource RESLICED_IMAGE_1 = pc2("wf/reslicedImage1");
    public static final Resource RESLICED_IMAGE_2 = pc2("wf/reslicedImage2");
    public static final Resource RESLICED_IMAGE_3 = pc2("wf/reslicedImage3");
    public static final Resource RESLICED_IMAGE_4 = pc2("wf/reslicedImage4");

    public static final Resource RESLICED_HEADER_1 = pc2("wf/reslicedHeader1");
    public static final Resource RESLICED_HEADER_2 = pc2("wf/reslicedHeader2");
    public static final Resource RESLICED_HEADER_3 = pc2("wf/reslicedHeader3");
    public static final Resource RESLICED_HEADER_4 = pc2("wf/reslicedHeader4");

    public static final Resource ATLAS_HEADER = pc2("wf/atlasHeader");
    public static final Resource ATLAS_IMAGE = pc2("wf/atlasImage");

    public static final Resource ATLAS_X_SLICE = pc2("wf/atlasXSlice");
    public static final Resource ATLAS_Y_SLICE = pc2("wf/atlasYSlice");
    public static final Resource ATLAS_Z_SLICEZ = pc2("wf/atlasZSlice");

    public static final Resource ATLAS_X_GRAPHIC = pc2("wf/atlasXGraphic");
    public static final Resource ATLAS_Y_GRAPHIC = pc2("wf/atlasYGraphic");
    public static final Resource ATLAS_Z_GRAPHIC = pc2("wf/atlasZGraphic");
}
