package org.tupeloproject.pchal2;

import java.util.Set;

import org.tupeloproject.kernel.Context;
import org.tupeloproject.kernel.OperatorException;
import org.tupeloproject.kernel.impl.MemoryContext;
import org.tupeloproject.rdf.Resource;
import static org.tupeloproject.rdf.Resource.uriRef;
import org.tupeloproject.rdf.Triple;
import static org.tupeloproject.rdf.Vocabulary.Owl;

/**
 * CesnetTest
 */
public class CesnetTest extends XslStrategy {

    public Set<Triple> infer(Set<Triple> groundTruth) throws OperatorException {
        Context c = new MemoryContext(groundTruth);
        c.addTriples(Triple.create(uriRef("urn:challenge:anatomy4_wf1.warp"),
                                   Owl.SAME_AS,
                                   uriRef("urn:challenge:anatomy4_yM3sz8v6WCIPgi5-0m8L4w.warp")));
        //
        return Owlet.sameAs(c);
    }

    protected String[] getFiles(int i) {
        String[] files = getFiles("/data/CESNET2/out",".xml","1","2","3");
        return new String[] { files[i-1] };
    }

    protected Resource getAtlasXGraphic() {
        return Resource.uriRef("urn:challenge:blabla-x_wf1.gif");
    }

    protected String getStylesheet() {
        return "cesnet2rdf.xsl";
    }

}
