package org.tupeloproject.pchal2;

import java.io.IOException;
import java.io.InputStream;
import java.net.URI;
import java.util.Set;

import org.tupeloproject.jena.Jena;
import org.tupeloproject.kernel.OperatorException;
import org.tupeloproject.rdf.Triple;

/**
 * TransformerBeanTest
 */
public abstract class TransformerStrategy extends Strategy {
    public Set<Triple> getTriples(String resourcePath) throws OperatorException, IOException {
        InputStream is = getClass().getResourceAsStream(resourcePath);
        return Jena.readTriples(is);
    }

    public Set<Triple> getTriples(String resourcePath, URI baseUri) throws OperatorException, IOException {
        InputStream is = getClass().getResourceAsStream(resourcePath);
        return Jena.readTriples(is,baseUri);
    }
}
