package org.tupeloproject.pchal2;

import java.util.Set;

import org.tupeloproject.kernel.Context;
import org.tupeloproject.kernel.OperatorException;
import org.tupeloproject.kernel.Transformer;
import org.tupeloproject.kernel.impl.MemoryContext;
import org.tupeloproject.rdf.Resource;
import org.tupeloproject.rdf.Triple;
import org.tupeloproject.rdf.Vocabulary;

/**
 * VisTrailsTest
 */
public class VisTrailsTest extends XslStrategy {

    public Set<Triple> infer(Set<Triple> groundTruth) throws OperatorException {
        Context c = new MemoryContext(groundTruth);
        // every pair of anything with the same label is the same
        Transformer t = new Transformer();
        t.addInPattern("thing1", Vocabulary.Rdfs.LABEL, "label");
        t.addInPattern("thing2", Vocabulary.Rdfs.LABEL, "label");
        t.addOutPattern("thing1", Vocabulary.Owl.SAME_AS, "thing2");
        xform(c,t); // skip this for now
        //
        return Owlet.sameAs(c);
    }

    protected String[] getFiles(int i) {
        String[] files = getFiles("/data/VisTrails2/pc_part",".xml","1","2","3a");
        return new String[] { files[i-1] };
    }

    protected Resource getAtlasXGraphic() {
        return Resource.uriRef("urn:moduleId:w204m7");
    }

    protected String getStylesheet() {
        return "vistrails2rdf.xsl";
    }
}
