<?xml version="1.0"?>
<!DOCTYPE stylesheet [
<!ENTITY rdf "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<!ENTITY t2 "tag:tupeloproject.org,2006:/2.0/pc2/">
<!ENTITY xsd "http://www.w3.org/2001/XMLSchema#">
<!ENTITY rdfs "http://www.w3.org/2000/01/rdf-schema#">
]>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:chal2="http://egee.cesnet.cz/en/Schema/JP/Challenge2">

  <xsl:include href="rdf-ntriples.xsl"/>

  <xsl:template match="/chal2:workflow/chal2:job">
    <!-- ?step rdf:type t2:Step -->
    <xsl:call-template name="triple">
      <xsl:with-param name="s">&lt;<xsl:value-of select="@id"/>&gt;</xsl:with-param>
      <xsl:with-param name="p">&rdf;type</xsl:with-param>
      <xsl:with-param name="o">&lt;&t2;Step&gt;</xsl:with-param>
    </xsl:call-template>
    <!-- ?step rdfs:label "{mnemonic label}" -->
    <xsl:call-template name="triple">
      <xsl:with-param name="s">&lt;<xsl:value-of select="@id"/>&gt;</xsl:with-param>
      <xsl:with-param name="p">&rdfs;label</xsl:with-param>
      <xsl:with-param name="o">&quot;<xsl:value-of select="chal2:annotations/chal2:annotation[chal2:name='http://egee.cesnet.cz/en/WSDL/jp-lbtag:IPAW_PROGRAM']/chal2:value"/>&quot;</xsl:with-param>
    </xsl:call-template>
    <!-- ?step t2:stepExecutedAt "{timestamp}" -->
    <xsl:call-template name="triple">
      <xsl:with-param name="s">&lt;<xsl:value-of select="@id"/>&gt;</xsl:with-param>
      <xsl:with-param name="p">&t2;stepExecutedAt</xsl:with-param>
      <xsl:with-param name="o">&quot;<xsl:value-of select="chal2:regtime"/>&quot;^^&lt;&xsd;dateTime&gt;</xsl:with-param>
    </xsl:call-template>
    <xsl:for-each select="chal2:inputs/chal2:file">
      <!-- ?step t2:stepHasInput ?input -->
      <xsl:call-template name="triple">
        <xsl:with-param name="s">&lt;<xsl:value-of select="../../@id"/>&gt;</xsl:with-param>
        <xsl:with-param name="p">&t2;stepHasInput</xsl:with-param>
        <xsl:with-param name="o">&lt;<xsl:value-of select="@name"/>&gt;</xsl:with-param>
      </xsl:call-template>
      <!-- ?input rdfs:label "{mnemonic label}" -->
      <xsl:call-template name="triple">
        <xsl:with-param name="s">&lt;<xsl:value-of select="@name"/>&gt;</xsl:with-param>
        <xsl:with-param name="p">&rdfs;label</xsl:with-param>
        <xsl:with-param name="o">&quot;<xsl:value-of select="@name"/>&quot;</xsl:with-param>
      </xsl:call-template>
    </xsl:for-each>
    <xsl:for-each select="chal2:outputs/chal2:file">
      <!-- ?step t2:stepHasOutput ?output -->
      <xsl:call-template name="triple">
        <xsl:with-param name="s">&lt;<xsl:value-of select="../../@id"/>&gt;</xsl:with-param>
        <xsl:with-param name="p">&t2;stepHasOutput</xsl:with-param>
        <xsl:with-param name="o">&lt;<xsl:value-of select="@name"/>&gt;</xsl:with-param>
      </xsl:call-template>
      <!-- ?output rdfs:label "{mnemonic label}" -->
      <xsl:call-template name="triple">
        <xsl:with-param name="s">&lt;<xsl:value-of select="@name"/>&gt;</xsl:with-param>
        <xsl:with-param name="p">&rdfs;label</xsl:with-param>
        <xsl:with-param name="o">&quot;<xsl:value-of select="@name"/>&quot;</xsl:with-param>
      </xsl:call-template>
    </xsl:for-each>
    <xsl:apply-templates select="chal2:annotations/chal2:annotation"/>
  </xsl:template>

  <xsl:template match="chal2:annotation">
    <xsl:call-template name="annotation">
      <xsl:with-param name="target">&lt;<xsl:value-of select="../../@id"/>&gt;</xsl:with-param>
      <xsl:with-param name="id">_:<xsl:value-of select="generate-id(.)"/></xsl:with-param>
      <xsl:with-param name="name"><xsl:value-of select="chal2:name"/></xsl:with-param>
      <xsl:with-param name="value"><xsl:value-of select="chal2:value"/></xsl:with-param>
    </xsl:call-template>
  </xsl:template>

</xsl:stylesheet>
