<?xml version="1.0"?>
<!DOCTYPE stylesheet [
<!ENTITY rdf "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<!ENTITY t2 "tag:tupeloproject.org,2006:/2.0/pc2/">
]>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="text" encoding="us-ascii"/>

  <!-- suppress default output -->
  <xsl:template match="text()|@*"/>

  <!-- generate a triple in N-Triples format -->
  <xsl:template name="triple">
    <xsl:param name="s"/>
    <xsl:param name="p"/>
    <xsl:param name="o"/>
    <xsl:value-of select="$s"/>
    <xsl:text> &lt;</xsl:text>
    <xsl:value-of select="$p"/>
    <xsl:text>&gt; </xsl:text>
    <xsl:value-of select="$o"/>
    <xsl:text> .
</xsl:text>
  </xsl:template>

  <xsl:template name="annotation">
    <xsl:param name="target"/>
    <xsl:param name="id"/>
    <xsl:param name="name"/>
    <xsl:param name="value"/>
    <xsl:call-template name="triple">
      <xsl:with-param name="s"><xsl:value-of select="$target"/></xsl:with-param>
      <xsl:with-param name="p">&t2;hasAnnotation</xsl:with-param>
      <xsl:with-param name="o"><xsl:value-of select="$id"/></xsl:with-param>
    </xsl:call-template>
    <xsl:call-template name="triple">
      <xsl:with-param name="s"><xsl:value-of select="$id"/></xsl:with-param>
      <xsl:with-param name="p">&t2;annotationHasName</xsl:with-param>
      <xsl:with-param name="o">&quot;<xsl:value-of select="$name"/>&quot;</xsl:with-param>
    </xsl:call-template>
    <xsl:call-template name="triple">
      <xsl:with-param name="s"><xsl:value-of select="$id"/></xsl:with-param>
      <xsl:with-param name="p">&t2;annotationHasValue</xsl:with-param>
      <xsl:with-param name="o">&quot;<xsl:value-of select="$value"/>&quot;</xsl:with-param>
    </xsl:call-template>
  </xsl:template>

</xsl:stylesheet>