<?xml version="1.0"?>
<!DOCTYPE stylesheet [
<!ENTITY rdf "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<!ENTITY t2 "tag:tupeloproject.org,2006:/2.0/pc2/">
<!ENTITY rdfs "http://www.w3.org/2000/01/rdf-schema#">
]>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:include href="rdf-ntriples.xsl"/>

  <xsl:template match="/workflow/connection">
    <xsl:variable name="source">
      <xsl:text>w</xsl:text>
      <xsl:value-of select="/workflow/@id"/>
      <xsl:text>m</xsl:text>
      <xsl:value-of select="port[@type='source']/@moduleId"/>
    </xsl:variable>
    <xsl:variable name="destination">
      <xsl:text>w</xsl:text>
      <xsl:value-of select="/workflow/@id"/>
      <xsl:text>m</xsl:text>
      <xsl:value-of select="port[@type='destination']/@moduleId"/>
    </xsl:variable>
    <xsl:variable name="bogusFile">
      <xsl:value-of select="$source"/>
      <xsl:value-of select="$destination"/>
    </xsl:variable>
    <!-- steps and their labels -->
    <xsl:call-template name="triple">
      <xsl:with-param name="s">&lt;urn:moduleId:<xsl:value-of select="$source"/>&gt;</xsl:with-param>
      <xsl:with-param name="p">&rdf;type</xsl:with-param>
      <xsl:with-param name="o">&lt;&t2;Step&gt;</xsl:with-param>
    </xsl:call-template>
    <xsl:call-template name="triple">
      <xsl:with-param name="s">&lt;urn:moduleId:<xsl:value-of select="$destination"/>&gt;</xsl:with-param>
      <xsl:with-param name="p">&rdf;type</xsl:with-param>
      <xsl:with-param name="o">&lt;&t2;Step&gt;</xsl:with-param>
    </xsl:call-template>
    <!-- bogus file -->
    <xsl:call-template name="triple">
      <xsl:with-param name="s">&lt;urn:bogusFile:<xsl:value-of select="$bogusFile"/>&gt;</xsl:with-param>
      <xsl:with-param name="p">&rdf;type</xsl:with-param>
      <xsl:with-param name="o">&lt;&t2;Dataset&gt;</xsl:with-param>
    </xsl:call-template>
    <xsl:call-template name="triple">
      <xsl:with-param name="s">&lt;urn:bogusFile:<xsl:value-of select="$bogusFile"/>&gt;</xsl:with-param>
      <xsl:with-param name="p">&rdfs;label</xsl:with-param>
      <xsl:with-param name="o">&quot;<xsl:value-of select="$bogusFile"/>&quot;</xsl:with-param>
    </xsl:call-template>
    <!-- input/output relationships -->
    <xsl:call-template name="triple">
      <xsl:with-param name="s">&lt;urn:moduleId:<xsl:value-of select="$source"/>&gt;</xsl:with-param>
      <xsl:with-param name="p">&t2;stepHasOutput</xsl:with-param>
      <xsl:with-param name="o">&lt;urn:bogusFile:<xsl:value-of select="$bogusFile"/>&gt;</xsl:with-param>
    </xsl:call-template>
    <xsl:call-template name="triple">
      <xsl:with-param name="s">&lt;urn:moduleId:<xsl:value-of select="$destination"/>&gt;</xsl:with-param>
      <xsl:with-param name="p">&t2;stepHasInput</xsl:with-param>
      <xsl:with-param name="o">&lt;urn:bogusFile:<xsl:value-of select="$bogusFile"/>&gt;</xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="/workflow/module[function[@name='name' or @name='baseName' or @name='outputBaseName']]">
    <xsl:variable name="moduleId">
      <xsl:text>w</xsl:text>
      <xsl:value-of select="/workflow/@id"/>
      <xsl:text>m</xsl:text>
      <xsl:value-of select="@id"/>
    </xsl:variable>
    <xsl:call-template name="triple">
      <xsl:with-param name="s">&lt;urn:moduleId:<xsl:value-of select="$moduleId"/>&gt;</xsl:with-param>
      <xsl:with-param name="p">&rdfs;label</xsl:with-param>
      <xsl:with-param name="o">&quot;<xsl:value-of select="function/parameter[1]/@val"/>&quot;</xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="/workflow/module[not(function[@name='name' or @name='baseName' or @name='outputBaseName'])]">
    <xsl:variable name="moduleId">
      <xsl:text>w</xsl:text>
      <xsl:value-of select="/workflow/@id"/>
      <xsl:text>m</xsl:text>
      <xsl:value-of select="@id"/>
    </xsl:variable>
    <xsl:call-template name="triple">
      <xsl:with-param name="s">&lt;urn:moduleId:<xsl:value-of select="$moduleId"/>&gt;</xsl:with-param>
      <xsl:with-param name="p">&rdfs;label</xsl:with-param>
      <xsl:with-param name="o">&quot;<xsl:value-of select="@name"/><xsl:value-of select="@id"/>&quot;</xsl:with-param>
    </xsl:call-template>
  </xsl:template>

</xsl:stylesheet>